﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MaxIm;

namespace MxPlugin_Version
{
    // COM Required Attributes for a custom coclass Interface
    // You must replace this GUID with a custom value.
    // Go to "Tools" > "Create GUID" to create your own.
    [Guid("03A8D901-2A21-4E5E-885E-73BE77CC9B3F")]
    [CoClass(typeof(PlugIn))]
    [ComImport]
    [InterfaceType(ComInterfaceType.InterfaceIsDual)]
    public interface _PlugIn
    {
        [DispId(0)] void DoModal([In, MarshalAs(UnmanagedType.Interface)] MaxIm.Document doc);

        [DispId(1)]
        [return: MarshalAs(UnmanagedType.BStr)]
        string Name();
    }

    // The coclass implementation of the COM Interface.
    // You must replace this GUID with a custom value.
    // Go to "Tools" > "Create GUID" to create your own.
    [Guid("F3AE9066-4B9E-434F-A083-455FEA3F2318")]
    [ClassInterface(ClassInterfaceType.AutoDual)]
    public class PlugIn : _PlugIn
    {
        /*!
         * \brief Class constructor
         * Default class contructor must be implemented for COM objects.
         */
        public PlugIn()
        {
            // Initialize the COM object.
        }

        /*!
         * \brief Function executed on PlugIn execute call.
         * DoModal is the function call passed through the COM to the PlugIn. Takes the currently open MaxIm DL document as an argument. 
         * \param MaxIm.Document doc Document to execute the plugin on. Provides direct access to the Image Buffer SAFEARRAY, rather than through a VARIANT array. 
         *        Is the open document with current focus in MaxIm DL.
         */
        public void DoModal(MaxIm.Document doc)
        {
            // Do stuff here.



            MaxIm.Application myApp = new MaxIm.Application();

            MessageBox.Show("MaxIm/DL Version : "+myApp.Version.ToString());
            _ = Marshal.ReleaseComObject(myApp);
        }


        /*!
         * \brief Returns the name of the PlugIn for use in the MaxIm DL GUI.
         * Returns the name of the PlugIn for use in the MaxIm DL GUI.
         */
        public string Name()
        {
            return "MaxIm DL Sample C# Plugin - Version";
        }
    }
}

